//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2001 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**
//**************************************************************************
//**
//**	Episode menu
//**
//**************************************************************************

#ifndef DOOM2

// MACROS ------------------------------------------------------------------

// CONSTANTS ---------------------------------------------------------------

// TYPES -------------------------------------------------------------------

struct menu_episode_t
{
	menu_t		menu;
	menutext_t	epi1;
	menutext_t	epi2;
	menutext_t	epi3;
	menutext_t	epi4;
	menutext_t	title;
};

// FUNCTION PROTOTYPES -----------------------------------------------------

void menu_skill(void);

// DATA DECLARATIONS -------------------------------------------------------

menu_episode_t	EpisodeMenu;

int				MenuEpisode;

// CODE --------------------------------------------------------------------

//==========================================================================
//
//	menu_episode_callback
//
//==========================================================================

void menu_episode_callback(menucommon_t *item, int msg)
{
	if (msg == MMSG_RECEIVE_FOCUS)
	{
		MenuEpisode = item->id;
	}
}

//==========================================================================
//
//	SharewareResponse
//
//==========================================================================

void SharewareResponse(int key)
{
	menu_help();
}

//==========================================================================
//
//	shareware_func
//
//==========================================================================

void shareware_func(void)
{
	MB_StartMessage("ONLY AVAILABLE IN THE REGISTERED VERSION", SharewareResponse, false);
}

//==========================================================================
//
//	menu_episode
//
//==========================================================================

void menu_episode(void)
{
	int x = 48;
	int y = 40;

    InitMenu(&EpisodeMenu.menu);

	MenuText_InitFunc(&EpisodeMenu.epi1, x, y, "Knee - Deep in the Dead", TEXT_BIG, menu_skill);
	EpisodeMenu.epi1.callback = menu_episode_callback;
	EpisodeMenu.epi1.id = 1;
	AddMenuItem(&EpisodeMenu.menu, &EpisodeMenu.epi1);
	y += 18;

	MenuText_InitFunc(&EpisodeMenu.epi2, x, y, "The Shores of Hell", TEXT_BIG,
		shareware ? shareware_func : menu_skill);
	EpisodeMenu.epi2.callback = menu_episode_callback;
	EpisodeMenu.epi2.id = 2;
	AddMenuItem(&EpisodeMenu.menu, &EpisodeMenu.epi2);
	y += 18;

	MenuText_InitFunc(&EpisodeMenu.epi3, x, y, "Inferno", TEXT_BIG,
		shareware ? shareware_func : menu_skill);
	EpisodeMenu.epi3.callback = menu_episode_callback;
	EpisodeMenu.epi3.id = 3;
	AddMenuItem(&EpisodeMenu.menu, &EpisodeMenu.epi3);
	y += 18;

	if (ExtendedWAD)
	{
		MenuText_InitFunc(&EpisodeMenu.epi4, x, y, "Thy Flesh Consumed", TEXT_BIG, menu_skill);
		EpisodeMenu.epi4.callback = menu_episode_callback;
		EpisodeMenu.epi4.id = 4;
		AddMenuItem(&EpisodeMenu.menu, &EpisodeMenu.epi4);
		y += 18;
	}

	MenuText_InitTitle(&EpisodeMenu.title, 160, 24, "WHICH EPISODE?", TEXT_BIGC);
	AddMenuItem(&EpisodeMenu.menu, &EpisodeMenu.title);

    PushMenu(&EpisodeMenu.menu);
}

#endif
