//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2000 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**	
//**************************************************************************

// MACROS ------------------------------------------------------------------

// CONSTANTS ---------------------------------------------------------------

// TYPES -------------------------------------------------------------------

// FUNCTION PROTOTYPES -----------------------------------------------------

// DATA DECLARATIONS -------------------------------------------------------

// CODE --------------------------------------------------------------------

//============================================================================
//
// 	A_CentaurAttack
//
//============================================================================

void A_CentaurAttack(mobj_t* actor)
{
	if (!actor->target)
	{
		return;
	}
	if (CheckMeleeRange(actor))
	{
		DamageMobj(actor->target, actor, actor, P_Random() % 7 + 3);
	}
}

//============================================================================
//
//	A_CentaurAttack2
//
//============================================================================

void A_CentaurAttack2(mobj_t* actor)
{
	if (!actor->target)
	{
		return;
	}
	SpawnMissile(actor, actor->target, MT_CENTAUR_FX);
	StartSoundName(actor, "CentaurLeaderAttack");
}

//============================================================================
//
//	A_SetInvulnerable
//
//============================================================================

void A_SetInvulnerable(mobj_t* actor)
{
	actor->flags2 |= MF2_INVULNERABLE;
}

//============================================================================
//
//	A_UnSetInvulnerable
//
//============================================================================

void A_UnSetInvulnerable(mobj_t* actor)
{
	actor->flags2 &= ~MF2_INVULNERABLE;
}

//============================================================================
//
// A_SetReflective
//
//============================================================================

void A_SetReflective(mobj_t* actor)
{
	actor->flags2 |= MF2_REFLECTIVE;

	if ((actor->type == MT_CENTAUR) ||
		(actor->type == MT_CENTAURLEADER))
	{
		A_SetInvulnerable(actor);
	}
}

//============================================================================
//
// A_UnSetReflective
//
//============================================================================

void A_UnSetReflective(mobj_t* actor)
{
	actor->flags2 &= ~MF2_REFLECTIVE;

	if ((actor->type == MT_CENTAUR) ||
		(actor->type == MT_CENTAURLEADER))
	{
		A_UnSetInvulnerable(actor);
	}
}

//============================================================================
//
// A_CentaurDefend
//
//============================================================================

void A_CentaurDefend(mobj_t* actor)
{
	A_FaceTarget(actor);
	if (CheckMeleeRange(actor) && P_Random() < 32)
	{
		A_UnSetInvulnerable(actor);
		SetMobjState(actor, actor->meleestate);
	}
}

//============================================================================
//
//	A_CentaurDropStuff
//
// 	Spawn shield/sword sprites when the centaur pulps
//
//============================================================================

void A_CentaurDropStuff(mobj_t* actor)
{
	mobj_t*	mo;
	angle_t	angle;

	mo = P_SpawnMobj(actor->origin.x, actor->origin.y, actor->origin.z + 45.0, MT_CENTAUR_SHIELD);
	if (mo)
	{
		angle = actor->angles.yaw + ANG90;
		mo->velocity.x = ((Random() - 0.5) * 8.0 + 1.0) * cos(angle) * 35.0;
		mo->velocity.y = ((Random() - 0.5) * 8.0 + 1.0) * sin(angle) * 35.0;
		mo->velocity.z = 8.0 + Random() * 4.0 * 35.0;
		mo->target = actor;
	}
	mo = P_SpawnMobj(actor->origin.x, actor->origin.y, actor->origin.z + 45.0, MT_CENTAUR_SWORD);
	if (mo)
	{
		angle = actor->angles.yaw - ANG90;
		mo->velocity.x = ((Random() - 0.5) * 8.0 + 1.0) * cos(angle) * 35.0;
		mo->velocity.y = ((Random() - 0.5) * 8.0 + 1.0) * sin(angle) * 35.0;
		mo->velocity.z = 8.0 + Random() * 4.0 * 35.0;
		mo->target = actor;
	}
}

//===========================================================================
//
//	A_CheckFloor
//
//	Checks if an object hit the floor
//
//===========================================================================

void A_CheckFloor(mobj_t* actor)
{
	if (actor->origin.z <= actor->floorz)
	{
		actor->origin.z = actor->floorz;
		actor->flags2 &= ~MF2_LOGRAV;
		SetMobjState(actor, actor->deathstate);
	}
}

