//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2000 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**	
//**************************************************************************

// MACROS ------------------------------------------------------------------

// CONSTANTS ---------------------------------------------------------------

// TYPES -------------------------------------------------------------------

// FUNCTION PROTOTYPES -----------------------------------------------------

// DATA DECLARATIONS -------------------------------------------------------

// CODE --------------------------------------------------------------------

//============================================================================
//
// 	A_LeafSpawn
//
//============================================================================

void A_LeafSpawn(mobj_t* actor)
{
	mobj_t*	mo;
	int 	i;

	for (i = (P_Random()&3)+1; i; i--)
	{
		mo = P_SpawnMobj(actor->origin.x + (Random() - Random()) * 64.0,
			actor->origin.y + (Random() - Random()) * 64.0,
			actor->origin.z + Random() * 64.0,
			MT_LEAF1+(P_Random()&1));
		if (mo)
		{
			P_ThrustMobj(mo, actor->angles.yaw, Random() * 2.0 + 3.0);
			mo->target = actor;
			mo->special1 = 0;
		}
	}
}

//============================================================================
//
// 	A_LeafThrust
//
//============================================================================

void A_LeafThrust(mobj_t* actor)
{
	if (P_Random() > 96)
	{
		return;
	}
	actor->velocity.z += (Random() * 2.0 + 1.0) * 35.0;
}

//============================================================================
//
// 	A_LeafCheck
//
//============================================================================

void A_LeafCheck(mobj_t* actor)
{
	actor->special1++;
	if (actor->special1 >= 20)
	{
		SetMobjState(actor, S_NULL);
		return;
	}
	if (P_Random() > 64)
	{
		if (!actor->velocity.x && !actor->velocity.y)
		{
			P_ThrustMobj(actor, actor->target->angles.yaw, Random() * 2.0 + 1.0);
		}
		return;
	}
	SetMobjState(actor, S_LEAF1_8);
	actor->velocity.z = (Random() * 2.0 + 1.0) * 35.0;
	P_ThrustMobj(actor, actor->target->angles.yaw, Random() * 2.0 + 2.0);
	actor->flags |= MF_MISSILE;
}

//===========================================================================
//
// 	A_TreeDeath
//
//===========================================================================

void A_TreeDeath(mobj_t* actor)
{
	if (!(actor->flags2&MF2_FIREDAMAGE))
	{
		actor->height *= 4.0;
		actor->flags |= MF_SHOOTABLE;
		actor->flags &= ~(MF_CORPSE+MF_DROPOFF);
		actor->health = 35;
		return;
	}
	else
	{
		SetMobjState(actor, actor->meleestate);
	}
}

