//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2001 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**	
//**************************************************************************

#include "asm_i386.h"

#ifdef USEASM

.text

//==========================================================================
//
//	D_DrawSpan8_16
//
//==========================================================================

	Align16
.globl C(D_DrawSpan8_16)
C(D_DrawSpan8_16):

	flds	fp_64k				// fp_64k
	fildl	C(ds_v)				// v | fp_64k
	fildl	C(ds_u)				// u | v | fp_64k
	fld		%st(0)				// u | u | v | fp_64k
	fmuls	C(d_sdivzstepu)	// u*sdivzstepu | u | v | fp_64k
	fld		%st(1)				// u | u*sdivzstepu | u | v | fp_64k
	fmuls	C(d_tdivzstepu)	// u*tdivzstepu | u*sdivzstepu | u | v | fp_64k
	fxch	%st(2)				// u | u*sdivzstepu | u*tdivzstepu | v | fp_64k
	fmuls	C(d_zistepu)		// u*zistepu | u*sdivzstepu | u*tdivzstepu | v | fp_64k
	fld		%st(3)				// v | u*zistepu | u*sdivzstepu | u*tdivzstepu | v | fp_64k
	fmuls	C(d_sdivzstepv)	// v*sdivzstepv | u*zistepu | u*sdivzstepu | u*tdivzstepu | v | fp_64k
	fld		%st(4)				// v | v*sdivzstepv | u*zistepu | u*sdivzstepu | u*tdivzstepu | v | fp_64k
	fmuls	C(d_tdivzstepv)	// v*tdivzstepv | v*sdivzstepv | u*zistepu | u*sdivzstepu | u*tdivzstepu | v | fp_64k
	fxch	%st(5)				// v | v*sdivzstepv | u*zistepu | u*sdivzstepu | u*tdivzstepu |	v*tdivzstepv | fp_64k
	fmuls	C(d_zistepv)		// v*zistepv | v*sdivzstepv | u*zistepu | u*sdivzstepu | u*tdivzstepu | v*tdivzstepv | fp_64k
	fxch	%st(3)				// u*sdivzstepu | v*sdivzstepv | u*zistepu | v*zistepv | u*tdivzstepu | v*tdivzstepv | fp_64k
	faddp	%st,%st(1)			// u*sdivzstepu+v*sdivzstepv | u*zistepu | v*zistepv | u*tdivzstepu | v*tdivzstepv | fp_64k
	fxch	%st(3)				// u*tdivzstepu | u*zistepu | v*zistepv | u*sdivzstepu+v*sdivzstepv | v*tdivzstepv | fp_64k
	faddp	%st,%st(4)			// u*zistepu | v*zistepv | u*sdivzstepu+v*sdivzstepv | u*tdivzstepu+v*tdivzstepv | fp_64k
	faddp	%st,%st(1)			// u*zistepu+v*zistepv | u*sdivzstepu+v*sdivzstepv | u*tdivzstepu+v*tdivzstepv | fp_64k
	fxch	%st(1)				// u*sdivzstepu+v*sdivzstepv | u*zistepu+v*zistepv | u*tdivzstepu+v*tdivzstepv | fp_64k
	fadds	C(d_sdivzorigin)	// sdivz | u*zistepu+v*zistepv | u*tdivzstepu+v*tdivzstepv | fp_64k
	fxch	%st(2)				// u*tdivzstepu+v*tdivzstepv | u*zistepu+v*zistepv | sdivz | fp_64k
	fadds	C(d_tdivzorigin)	// tdivz | u*zistepu+v*zistepv | sdivz | fp_64k
	fxch	%st(1)				// u*zistepu+v*zistepv | tdivz | sdivz | fp_64k
	fadds	C(d_ziorigin)		// zi | tdivz | sdivz | fp_64k
	fxch	%st(2)				// sdivz | tdivz | zi | fp_64k

	//	Start fdiv for the start of the span
	fld		%st(3)				// fp_64k | s | t | v | fp_64k
	fdiv	%st(3),%st			// fp_64k/v | s | t | v | fp_64k

	pushl	%ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx

	movl	C(ds_l),%eax
	movl	%eax,tmplight

	movl	C(ds_source),%esi

	movl	C(ds_v),%eax
	movl	C(ylookup)(,%eax,4),%edi
	addl	C(ds_u),%edi
	addl	%edi,%edi
	addl	C(scrn16),%edi

	movl	C(ds_count),%ecx

	cmpl	$8,%ecx
	ja		LSetupNotLast1

	decl	%ecx
	jz		LJustOnePixel

	fld		%st			// fp_64k/v | fp_64k/v | s | t | v | fp_64k
	fmul	%st(2),%st	// s*fp_64k/v | fp_64k/v | s | t | v | fp_64k
	fistpl	s			// fp_64k/v | s | t | v | fp_64k
	fmul	%st(2),%st	// t*fp_64k/v | s | t | v | fp_64k
	fistpl	t			// s | t | v | fp_64k

	movl	s,%ebx
	movl	t,%ebp

	movl	%ecx,spancountminus1
	// s0 | t0 | v0 | fp_64k
	fildl	spancountminus1	// scm1 | s0 | t0 | v0 | fp_64k
	fld		%st			// scm1 | scm1 | s0 | t0 | v0 | fp_64k
	fmuls	C(d_sdivzstepu)	// dsdx*dsdx | scm1 | s0 | t0 | v0 | fp_64k
	faddp	%st,%st(2)	// scm1 | s | t0 | v0 | fp_64k
	fld		%st			// scm1 | scm1 | s | t0 | v0 | fp_64k
	fmuls	C(d_tdivzstepu)	// dtdx*scm1 | scm1 | s | t0 | v0 | fp_64k
	faddp	%st,%st(3)	// scm1 | s | t | v0 | fp_64k
	fmuls	C(d_zistepu)	// dvdx*scm1 | s | t | v0 | fp_64k
	faddp	%st,%st(3)	// s | t | v | fp_64k

	fld		%st(3)		// fp_64k | s | t | v | fp_64k
	fdiv	%st(3),%st	// fp_64k/v | s | t | v | fp_64k

	fld		%st			// fp_64k/v | fp_64k/v | s | t | v | fp_64k
	fmul	%st(2),%st	// s*fp_64k/v | fp_64k/v | s | t | v | fp_64k
	fistpl	snext		// fp_64k/v | s | t | v | fp_64k
	fmul	%st(2),%st	// t*fp_64k/v | s | t | v | fp_64k
	fistpl	tnext		// s | t | v | fp_64k

	jmp		LDrawLastPixels

LJustOnePixel:

	fld		%st			// fp_64k/v | fp_64k/v | s | t | v | fp_64k
	fmul	%st(2),%st	// s*fp_64k/v | fp_64k/v | s | t | v | fp_64k
	fistpl	s			// fp_64k/v | s | t | v | fp_64k
	fmul	%st(2),%st	// t*fp_64k/v | s | t | v | fp_64k
	fistpl	t			// s | t | v | fp_64k

	movl	s,%ebx
	movl	t,%ebp

	jmp		L16Entry1

	Align16
LSetupNotLast1:

	//	Finish s and t calculations
	fld		%st			// fp_64k/v | fp_64k/v | s | t | v | fp_64k
	fmul	%st(2),%st	// s*fp_64k/v | fp_64k/v | s | t | v | fp_64k
	fistpl	s			// fp_64k/v | s | t | v | fp_64k
	fmul	%st(2),%st	// t*fp_64k/v | s | t | v | fp_64k
	fistpl	t			// s | t | v | fp_64k

	flds	fp_8		// 8 | s0 | t0 | v0 | fp_64k
	fmuls	C(d_sdivzstepu)	// sdivz8stepu | s0 | t0 | v0 | fp_64k
	fadd	%st,%st(1)	// sdivz8stepu | s | t0 | v0 | fp_64k
	fstps	sdivz8stepu		// s | t0 | v0 | fp_64k
	flds	fp_8		// 8 | s | t0 | v0 | fp_64k
	fmuls	C(d_tdivzstepu)	// tdivz8stepu | s | t0 | v0 | fp_64k
	fadd	%st,%st(2)	// tdivz8stepu | s | t | v0 | fp_64k
	fstps	tdivz8stepu		// s | t | v0 | fp_64k
	flds	fp_8		// 8 | s | t | v0 | fp_64k
	fmuls	C(d_zistepu)	// zi8stepu | s | t | v0 | fp_64k
	fadd	%st,%st(3)	// zi8stepu | s | t | v | fp_64k
	fstps	zi8stepu		// s | t | v | fp_64k

	fld		%st(3)		// fp_64k | s | t | v | fp_64k
	fdiv	%st(3),%st	// fp_64k/v | s | t | v | fp_64k

	jmp		LSegmentLoop2

	//-------------------

	Align16
LSetupNotLast2:
	movl	snext,%ebx
	movl	tnext,%ebp
	movl	%ebx,s
	movl	%ebp,t

LSegmentLoop2:
	movl	C(ds_lstepu),%ebx
	movl	tmplight,%edx
	movl	C(ds_colormap16),%ebp

//	EBX -  ds_lstepu
//	EDX - tmplight
//	EBP - ds_colormap

	addl	$-8,%ecx
	movl	%ecx,count

	cmpl	$8,%ecx
	ja		LSetupNotLast3

	decl	%ecx
	jz		LSetupOnePixel

	fld		%st			// fp_64k/v | fp_64k/v | s | t | v | fp_64k

	movl	%edx,%eax
	shrl	$11,%eax

	fmul	%st(2),%st	// s*fp_64k/v | fp_64k/v | s | t | v | fp_64k

	andl	$0x1f00,%eax
	leal	(%ebp,%eax,2),%eax
	movl	%eax,cmap1
	addl	%ebx,%edx

	fistpl	snext		// fp_64k/v | s | t | v | fp_64k

	movl	%edx,%eax
	shrl	$11,%eax

	fmul	%st(2),%st	// t*fp_64k/v | s | t | v | fp_64k

	andl	$0x1f00,%eax
	leal	(%ebp,%eax,2),%eax
	movl	%eax,cmap2
	addl	%ebx,%edx

	fistpl	tnext		// s | t | v | fp_64k

	movl	%ecx,spancountminus1
	// s0 | t0 | v0 | fp_64k
	fildl	spancountminus1	// scm1 | s0 | t0 | v0 | fp_64k
	fld		%st			// scm1 | scm1 | s0 | t0 | v0 | fp_64k

	movl	%edx,%eax
	shrl	$11,%eax

	flds	C(d_sdivzstepu)	// dsdx | dsdx | scm1 | s0 | t0 | v0 | fp_64k

	andl	$0x1f00,%eax
	leal	(%ebp,%eax,2),%eax

	fmulp	%st,%st(1)	// dsdx*dsdx | scm1 | s0 | t0 | v0 | fp_64k

	movl	%eax,cmap3
	addl	%ebx,%edx

	movl	%edx,%eax
	shrl	$11,%eax

	faddp	%st,%st(2)	// scm1 | s | t0 | v0 | fp_64k

	andl	$0x1f00,%eax
	leal	(%ebp,%eax,2),%eax
	movl	%eax,cmap4
	addl	%ebx,%edx

	fld		%st			// scm1 | scm1 | s | t0 | v0 | fp_64k

	movl	%edx,%eax
	shrl	$11,%eax

	flds	C(d_tdivzstepu)	// dtdx | scm1 | scm1 | s | t0 | v0 | fp_64k

	andl	$0x1f00,%eax
	leal	(%ebp,%eax,2),%eax

	fmulp	%st,%st(1)	// dtdx*scm1 | scm1 | s | t0 | v0 | fp_64k

	movl	%eax,cmap5
	addl	%ebx,%edx

	movl	%edx,%eax
	shrl	$11,%eax

	faddp	%st,%st(3)	// scm1 | s | t | v0 | fp_64k

	andl	$0x1f00,%eax
	leal	(%ebp,%eax,2),%eax
	movl	%eax,cmap6
	addl	%ebx,%edx

	flds	C(d_zistepu)	// dvdx | scm1 | s | t | v0 | fp_64k

	movl	%edx,%eax
	shrl	$11,%eax

	fmulp	%st,%st(1)	// dvdx*scm1 | s | t | v0 | fp_64k

	andl	$0x1f00,%eax
	leal	(%ebp,%eax,2),%eax
	movl	%eax,cmap7
	addl	%ebx,%edx

	faddp	%st,%st(3)	// s | t | v | fp_64k

	movl	%edx,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax
	leal	(%ebp,%eax,2),%eax

	fld		%st(3)		// fp_64k | s | t | v | fp_64k

	movl	%eax,cmap8
	addl	%ebx,%edx

	fdiv	%st(3),%st	// fp_64k/v | s | t | v | fp_64k

	jmp		LFDivOnFlight

	Align16
LSetupOnePixel:

	movl	%edx,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax
	leal	(%ebp,%eax,2),%eax
	movl	%eax,cmap1
	addl	%ebx,%edx

	fld		%st			// fp_64k/v | fp_64k/v | s | t | v | fp_64k

	movl	%edx,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax
	leal	(%ebp,%eax,2),%eax
	movl	%eax,cmap2
	addl	%ebx,%edx

	movl	%edx,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax
	leal	(%ebp,%eax,2),%eax
	movl	%eax,cmap3
	addl	%ebx,%edx

	fmul	%st(2),%st	// s*fp_64k/v | fp_64k/v | s | t | v | fp_64k

	movl	%edx,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax
	leal	(%ebp,%eax,2),%eax
	movl	%eax,cmap4
	addl	%ebx,%edx

	movl	%edx,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax
	leal	(%ebp,%eax,2),%eax
	movl	%eax,cmap5
	addl	%ebx,%edx

	fistpl	snext		// fp_64k/v | s | t | v | fp_64k

	movl	%edx,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax
	leal	(%ebp,%eax,2),%eax
	movl	%eax,cmap6
	addl	%ebx,%edx

	fmul	%st(2),%st	// t*fp_64k/v | s | t | v | fp_64k

	movl	%edx,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax
	leal	(%ebp,%eax,2),%eax
	movl	%eax,cmap7
	addl	%ebx,%edx

	movl	%edx,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax
	leal	(%ebp,%eax,2),%eax
	movl	%eax,cmap8
	addl	%ebx,%edx

	fistpl	tnext		// s | t | v | fp_64k

	jmp		LFDivOnFlight

	Align16
LSetupNotLast3:
	movl	%edx,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax
	leal	(%ebp,%eax,2),%eax
	movl	%eax,cmap1
	addl	%ebx,%edx

	fld		%st			// fp_64k/v | fp_64k/v | s | t | v | fp_64k

	movl	%edx,%eax
	shrl	$11,%eax

	fmul	%st(2),%st	// s*fp_64k/v | fp_64k/v | s | t | v | fp_64k

	andl	$0x1f00,%eax
	leal	(%ebp,%eax,2),%eax
	movl	%eax,cmap2
	addl	%ebx,%edx

	movl	%edx,%eax
	shrl	$11,%eax

	fistpl	snext		// fp_64k/v | s | t | v | fp_64k

	andl	$0x1f00,%eax
	leal	(%ebp,%eax,2),%eax

	fmul	%st(2),%st	// t*fp_64k/v | s | t | v | fp_64k

	movl	%eax,cmap3
	addl	%ebx,%edx

	movl	%edx,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax
	leal	(%ebp,%eax,2),%eax
	movl	%eax,cmap4
	addl	%ebx,%edx

	fistpl	tnext		// s | t | v | fp_64k

	movl	%edx,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax
	leal	(%ebp,%eax,2),%eax

	// s0 | t0 | v0 | fp_64k
	flds	sdivz8stepu		// sdivz8stepu | s | t0 | v0 | fp_64k

	movl	%eax,cmap5
	addl	%ebx,%edx

	faddp	%st,%st(1)	// s | t0 | v0 | fp_64k

	movl	%edx,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax

	flds	tdivz8stepu		// tdivz8stepu | s | t0 | v0 | fp_64k

	leal	(%ebp,%eax,2),%eax
	movl	%eax,cmap6
	addl	%ebx,%edx

	faddp	%st,%st(2)	// s | t | v0 | fp_64k

	movl	%edx,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax

	flds	zi8stepu		// zi8stepu | s | t | v0 | fp_64k

	leal	(%ebp,%eax,2),%eax
	movl	%eax,cmap7
	addl	%ebx,%edx

	faddp	%st,%st(3)	// s | t | v | fp_64k

	movl	%edx,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax

	fld		%st(3)		// fp_64k | s | t | v | fp_64k

	leal	(%ebp,%eax,2),%eax
	movl	%eax,cmap8
	addl	%ebx,%edx

	fdiv	%st(3),%st	// fp_64k/v | s | t | v | fp_64k

LFDivOnFlight:
	movl	%edx,tmplight

//	EDI - dest

	movl	s,%ebx
	movl	t,%ebp

	movl	snext,%eax
	subl	%ebx,%eax
	shrl	$3,%eax
	movl	%eax,sstep

	movl	tnext,%ecx
	subl	%ebp,%ecx
	shrl	$3,%ecx

	addl	C(sadjust),%ebx
	addl	C(tadjust),%ebp

//	EBX - s
//	ECX - tstep
//	EDI - dest
//	ESI - source
//	EBP - sstep

	movl	%ebx,%eax
	movl	%ebp,%edx
	shrl	$16,%eax
	andl	$0xff0000,%edx
	shrl	$8,%edx
	andl	$255,%eax
	orl		%eax,%edx
	movzbl	(%edx,%esi),%edx
	movl	cmap1,%eax
	movw	(%eax,%edx,2),%ax
	movw	%ax,(%edi)
	addl	sstep,%ebx
	addl	%ecx,%ebp

	movl	%ebx,%eax
	movl	%ebp,%edx
	shrl	$16,%eax
	andl	$0xff0000,%edx
	shrl	$8,%edx
	andl	$255,%eax
	orl		%eax,%edx
	movzbl	(%edx,%esi),%edx
	movl	cmap2,%eax
	movw	(%eax,%edx,2),%ax
	movw	%ax,2(%edi)
	addl	sstep,%ebx
	addl	%ecx,%ebp

	movl	%ebx,%eax
	movl	%ebp,%edx
	shrl	$16,%eax
	andl	$0xff0000,%edx
	shrl	$8,%edx
	andl	$255,%eax
	orl		%eax,%edx
	movzbl	(%edx,%esi),%edx
	movl	cmap3,%eax
	movw	(%eax,%edx,2),%ax
	movw	%ax,4(%edi)
	addl	sstep,%ebx
	addl	%ecx,%ebp

	movl	%ebx,%eax
	movl	%ebp,%edx
	shrl	$16,%eax
	andl	$0xff0000,%edx
	shrl	$8,%edx
	andl	$255,%eax
	orl		%eax,%edx
	movzbl	(%edx,%esi),%edx
	movl	cmap4,%eax
	movw	(%eax,%edx,2),%ax
	movw	%ax,6(%edi)
	addl	sstep,%ebx
	addl	%ecx,%ebp

	movl	%ebx,%eax
	movl	%ebp,%edx
	shrl	$16,%eax
	andl	$0xff0000,%edx
	shrl	$8,%edx
	andl	$255,%eax
	orl		%eax,%edx
	movzbl	(%edx,%esi),%edx
	movl	cmap5,%eax
	movw	(%eax,%edx,2),%ax
	movw	%ax,8(%edi)
	addl	sstep,%ebx
	addl	%ecx,%ebp

	movl	%ebx,%eax
	movl	%ebp,%edx
	shrl	$16,%eax
	andl	$0xff0000,%edx
	shrl	$8,%edx
	andl	$255,%eax
	orl		%eax,%edx
	movzbl	(%edx,%esi),%edx
	movl	cmap6,%eax
	movw	(%eax,%edx,2),%ax
	movw	%ax,10(%edi)
	addl	sstep,%ebx
	addl	%ecx,%ebp

	movl	%ebx,%eax
	movl	%ebp,%edx
	shrl	$16,%eax
	andl	$0xff0000,%edx
	shrl	$8,%edx
	andl	$255,%eax
	orl		%eax,%edx
	movzbl	(%edx,%esi),%edx
	movl	cmap7,%eax
	movw	(%eax,%edx,2),%ax
	movw	%ax,12(%edi)
	addl	sstep,%ebx
	addl	%ecx,%ebp

	movl	%ebx,%eax
	movl	%ebp,%edx
	shrl	$16,%eax
	andl	$0xff0000,%edx
	shrl	$8,%edx
	andl	$255,%eax
	orl		%eax,%edx
	movzbl	(%edx,%esi),%edx
	movl	cmap8,%eax
	movw	(%eax,%edx,2),%ax
	movw	%ax,14(%edi)

	addl	$16,%edi

	movl	count,%ecx
	cmpl	$8,%ecx
	ja		LSetupNotLast2

	//
	//	Last segment
	//

	movl	snext,%ebx
	movl	tnext,%ebp

	decl	%ecx
	jz		L16Entry1

	fld		%st			// fp_64k/v | fp_64k/v | s | t | v | fp_64k
	fmul	%st(2),%st	// s*fp_64k/v | fp_64k/v | s | t | v | fp_64k
	fistpl	snext		// fp_64k/v | s | t | v | fp_64k
	fmul	%st(2),%st	// t*fp_64k/v | s | t | v | fp_64k
	fistpl	tnext		// s | t | v | fp_64k

LDrawLastPixels:
	cmpl	$1,%ecx
	je		LEntry2

	// convert to 15.17 format so multiply by 1.31 reciprocal yields 16.48

	movl	snext,%eax
	subl	%ebx,%eax
	addl	%eax,%eax
	imull	reciprocal_table-8(,%ecx,4) // sstep = (snext - s) / (spancount-1)
	movl	%edx,sstep

	movl	tnext,%eax
	subl	%ebp,%eax
	addl	%eax,%eax
	imull	reciprocal_table-8(,%ecx,4) // tstep = (tnext - t) / (spancount-1)
	movl	%edx,tstep

	movl	%ecx,%eax
	movl	C(ds_colormap16),%ecx

	addl	C(sadjust),%ebx
	addl	C(tadjust),%ebp

	jmp		*LEntryTable(,%eax,4)

	Align16
LEntryTable:
	.long	0
	.long	LEntry2
	.long	LEntry3
	.long	LEntry4
	.long	LEntry5
	.long	LEntry6
	.long	LEntry7
	.long	LEntry8

	Align16
LEntry8:
	movl	%ebp,%edx
	shrl	$8,%edx
	andl	$65280,%edx
	movl	%ebx,%eax
	shrl	$16,%eax
	andl	$255,%eax
	orl		%eax,%edx
	movzbl	(%edx,%esi),%edx
	movl	tmplight,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax
	orl		%eax,%edx
	movw	(%ecx,%edx,2),%ax
	movw	%ax,(%edi)
	movl	C(ds_lstepu),%eax
	addl	%eax,tmplight
	addl	sstep,%ebx
	addl	tstep,%ebp

LLEntry7:
	movl	%ebp,%edx
	shrl	$8,%edx
	andl	$65280,%edx
	movl	%ebx,%eax
	shrl	$16,%eax
	andl	$255,%eax
	orl		%eax,%edx
	movzbl	(%edx,%esi),%edx
	movl	tmplight,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax
	orl		%eax,%edx
	movw	(%ecx,%edx,2),%ax
	movw	%ax,2(%edi)
	movl	C(ds_lstepu),%eax
	addl	%eax,tmplight
	addl	sstep,%ebx
	addl	tstep,%ebp

LLEntry6:
	movl	%ebp,%edx
	shrl	$8,%edx
	andl	$65280,%edx
	movl	%ebx,%eax
	shrl	$16,%eax
	andl	$255,%eax
	orl		%eax,%edx
	movzbl	(%edx,%esi),%edx
	movl	tmplight,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax
	orl		%eax,%edx
	movw	(%ecx,%edx,2),%ax
	movw	%ax,4(%edi)
	movl	C(ds_lstepu),%eax
	addl	%eax,tmplight
	addl	sstep,%ebx
	addl	tstep,%ebp

LLEntry5:
	movl	%ebp,%edx
	shrl	$8,%edx
	andl	$65280,%edx
	movl	%ebx,%eax
	shrl	$16,%eax
	andl	$255,%eax
	orl		%eax,%edx
	movzbl	(%edx,%esi),%edx
	movl	tmplight,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax
	orl		%eax,%edx
	movw	(%ecx,%edx,2),%ax
	movw	%ax,6(%edi)
	movl	C(ds_lstepu),%eax
	addl	%eax,tmplight
	addl	sstep,%ebx
	addl	tstep,%ebp

LLEntry4:
	movl	%ebp,%edx
	shrl	$8,%edx
	andl	$65280,%edx
	movl	%ebx,%eax
	shrl	$16,%eax
	andl	$255,%eax
	orl		%eax,%edx
	movzbl	(%edx,%esi),%edx
	movl	tmplight,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax
	orl		%eax,%edx
	movw	(%ecx,%edx,2),%ax
	movw	%ax,8(%edi)
	movl	C(ds_lstepu),%eax
	addl	%eax,tmplight
	addl	sstep,%ebx
	addl	tstep,%ebp

LLEntry3:
	movl	%ebp,%edx
	shrl	$8,%edx
	andl	$65280,%edx
	movl	%ebx,%eax
	shrl	$16,%eax
	andl	$255,%eax
	orl		%eax,%edx
	movzbl	(%edx,%esi),%edx
	movl	tmplight,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax
	orl		%eax,%edx
	movw	(%ecx,%edx,2),%ax
	movw	%ax,10(%edi)
	movl	C(ds_lstepu),%eax
	addl	%eax,tmplight
	addl	sstep,%ebx
	addl	tstep,%ebp

	movl	%ebp,%edx
	shrl	$8,%edx
	andl	$65280,%edx
	movl	%ebx,%eax
	shrl	$16,%eax
	andl	$255,%eax
	orl		%eax,%edx
	movzbl	(%edx,%esi),%edx
	movl	tmplight,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax
	orl		%eax,%edx
	movw	(%ecx,%edx,2),%ax
	movw	%ax,12(%edi)
	movl	C(ds_lstepu),%eax
	addl	%eax,tmplight
	addl	sstep,%ebx
	addl	tstep,%ebp

	shrl	$8,%ebp
	andl	$65280,%ebp
	shrl	$16,%ebx
	andl	$255,%ebx
	orl		%ebx,%ebp
	movzbl	(%ebp,%esi),%edx
	movl	tmplight,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax
	orl		%eax,%edx
	movw	(%ecx,%edx,2),%ax
	movw	%ax,14(%edi)

	jmp		LExit

	Align16
LEntry7:
	subl	$2,%edi
	jmp		LLEntry7

	Align16
LEntry6:
	subl	$4,%edi
	jmp		LLEntry6

	Align16
LEntry5:
	subl	$6,%edi
	jmp		LLEntry5

	Align16
LEntry4:
	subl	$8,%edi
	jmp		LLEntry4

	Align16
LEntry3:
	subl	$10,%edi
	jmp		LLEntry3

	Align16
LEntry2:
	movl	C(ds_colormap16),%ecx

	addl	C(sadjust),%ebx
	addl	C(tadjust),%ebp

	movl	%ebp,%edx
	shrl	$8,%edx
	andl	$65280,%edx
	movl	%ebx,%eax
	shrl	$16,%eax
	andl	$255,%eax
	orl		%eax,%edx
	movzbl	(%edx,%esi),%edx
	movl	tmplight,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax
	orl		%eax,%edx
	movw	(%ecx,%edx,2),%ax
	movw	%ax,(%edi)

	movl	tnext,%edx
	addl	C(tadjust),%edx
	shrl	$8,%edx
	andl	$65280,%edx
	movl	snext,%eax
	addl	C(sadjust),%eax
	shrl	$16,%eax
	andl	$255,%eax
	orl		%eax,%edx
	movzbl	(%edx,%esi),%edx
	movl	tmplight,%eax
	addl	C(ds_lstepu),%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax
	orl		%eax,%edx
	movw	(%ecx,%edx,2),%ax
	movw	%ax,2(%edi)

	jmp		LExit

	Align16
L16Entry1:
	movl	C(ds_colormap16),%ecx

	addl	C(sadjust),%ebx
	addl	C(tadjust),%ebp

	shrl	$8,%ebp
	andl	$65280,%ebp
	shrl	$16,%ebx
	andl	$255,%ebx
	orl		%ebx,%ebp
	movzbl	(%ebp,%esi),%edx
	movl	tmplight,%eax
	shrl	$11,%eax
	andl	$0x1f00,%eax
	orl		%eax,%edx
	movw	(%ecx,%edx,2),%ax
	movw	%ax,(%edi)
//#ifdef GAS2TASM
//	jmp		LExit		//FIXME
//#endif

//	Align16
LExit:
	fstp	%st(0)
	fstp	%st(0)
	fstp	%st(0)
	fstp	%st(0)
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp

	jmp		C(D_DrawZSpan)

#endif
