//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2001 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**	
//**************************************************************************

// HEADER FILES ------------------------------------------------------------

#include "d_local.h"

// MACROS ------------------------------------------------------------------

// TYPES -------------------------------------------------------------------

// EXTERNAL FUNCTION PROTOTYPES --------------------------------------------

// PUBLIC FUNCTION PROTOTYPES ----------------------------------------------

// PRIVATE FUNCTION PROTOTYPES ---------------------------------------------

// EXTERNAL DATA DECLARATIONS ----------------------------------------------

// PUBLIC DATA DEFINITIONS -------------------------------------------------

// PRIVATE DATA DEFINITIONS ------------------------------------------------

// CODE --------------------------------------------------------------------

#ifndef USEASM

//==========================================================================
//
//	D_DrawZSpan
//
//==========================================================================

extern "C" void D_DrawZSpan(void)
{
    word *zdst = zbuffer + (ylookup[ds_v] + ds_u);
	int count = ds_count;
	double zi = ds_u * d_zistepu + ds_v * d_zistepv + d_ziorigin;
	int izi = (int)(zi * 0x8000 * 0x10000);
	int izistepu = (int)(d_zistepu * 0x8000 * 0x10000);

	if ((long)zdst & 0x02)
	{
		//	Align dest to dword
		*zdst++ = izi >> 16;
		izi += izistepu;
		count--;
	}

	int doublecount = count >> 1;
	if (doublecount > 0)
	{
		//	Process pixels by 2 pixels at time
		do
	    {
			dword zval;

			zval = izi >> 16;
			izi += izistepu;
			zval |= izi & 0xffff0000;
			izi += izistepu;

			*(dword*)zdst = zval;
			zdst += 2;
		} while (--doublecount);
	}

	if (count & 1)
    {
		//	Process remaining pixel (if there is any)
		*zdst = izi >> 16;
	}
}

#endif	//	USEASM

