//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2001 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**	
//**************************************************************************

#include "asm_i386.h"

#ifdef USEASM

.data
	Align4

//==========================================================================
//
//	Global rasterizer variables
//
//==========================================================================

.globl	C(ds_u)
.globl	C(ds_v)
.globl	C(ds_count)
C(ds_u):			.long	0
C(ds_v):			.long	0
C(ds_count):		.long	0

.globl	C(d_sdivzstepu)
.globl	C(d_tdivzstepu)
.globl	C(d_zistepu)
.globl	C(d_sdivzstepv)
.globl	C(d_tdivzstepv)
.globl	C(d_zistepv)
.globl	C(d_sdivzorigin)
.globl	C(d_tdivzorigin)
.globl	C(d_ziorigin)
C(d_sdivzstepu):	.single	0
C(d_tdivzstepu):	.single	0
C(d_zistepu):		.single	0
C(d_sdivzstepv):	.single	0
C(d_tdivzstepv):	.single	0
C(d_zistepv):		.single	0
C(d_sdivzorigin):	.single	0
C(d_tdivzorigin):	.single	0
C(d_ziorigin):		.single	0

.globl	C(sadjust)
.globl	C(tadjust)
.globl	C(bbextents)
.globl	C(bbextentt)
C(sadjust):			.long	0
C(tadjust):			.long	0
C(bbextents):		.long	0
C(bbextentt):		.long	0

.globl	C(ds_l)
.globl	C(ds_lstepu)
C(ds_l):			.long	0
C(ds_lstepu):		.long	0

.globl	C(ds_source)
.globl	C(ds_colormap)
.globl	C(ds_colormap16)
.globl	C(ds_tex_width)
.globl	C(ds_transluc)
.globl	C(ds_transluc16)
C(ds_source):		.long	0
C(ds_colormap):		.long	0
C(ds_colormap16):	.long	0
C(ds_tex_width):	.long	0
C(ds_transluc):		.long	0
C(ds_transluc16):	.long	0

//==========================================================================
//
//	Asm only vars
//
//==========================================================================

.globl	sdivz8stepu
.globl	tdivz8stepu
.globl	zi8stepu
sdivz8stepu:		.single	0
tdivz8stepu:		.single	0
zi8stepu:			.single	0

.globl	s
.globl	t
.globl	snext
.globl	tnext
.globl	sstep
.globl	tstep
.globl	sfracf
.globl	tfracf
.globl	count
.globl	spancountminus1
s:					.long	0
t:					.long	0
snext:				.long	0
tnext:				.long	0
sstep:				.long	0
tstep:				.long	0
sfracf:				.long	0
tfracf:				.long	0
count:				.long	0
spancountminus1:	.long	0

.globl	izi
.globl	izistep
izi:				.long	0
izistep:			.long	0

.globl	advancetable
advancetable:		.long	0, 0, 2, 0

.globl	pbase
.globl	pz
pbase:				.long	0
pz:					.long	0

.globl	tmplight
.globl	cmap1
.globl	cmap2
.globl	cmap3
.globl	cmap4
.globl	cmap5
.globl	cmap6
.globl	cmap7
.globl	cmap8
tmplight:			.long	0
cmap1:				.long	0
cmap2:				.long	0
cmap3:				.long	0
cmap4:				.long	0
cmap5:				.long	0
cmap6:				.long	0
cmap7:				.long	0
cmap8:				.long	0

.globl	reciprocal_table
// 1/2, 1/3, 1/4, 1/5, 1/6, and 1/7 in 0.32 form
reciprocal_table:	.long	0x40000000, 0x2aaaaaaa, 0x20000000
					.long	0x19999999, 0x15555555, 0x12492492

.globl	mmbuf
	Align8
mmbuf:				.long	0
					.long	0

.globl	fp_8
.globl	fp_64k
.globl	Float2ToThe31nd
.globl	fp_64kx64k
fp_8:				.long	0x41000000
fp_64k:				.long	0x47800000
Float2ToThe31nd:	.long	0x4f000000
fp_64kx64k:			.long	0x4f000000

#endif
